/**
misModPublisher
    Copyright (C) 2020  Theros@Svaltek / Public

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/
using System;

namespace misModPublisher
{
    using System.Collections.Generic;
    using System.Diagnostics;
    using System.IO;
    using System.Linq;
    using System.Threading.Tasks;
    using CommandLineParser;
    using CommandLineParser.Arguments;

    // Update 23/10/2020
    /**
     * Added Azure AppCenter Support.
     */

    using Microsoft.AppCenter;
    using Microsoft.AppCenter.Analytics;
    using Microsoft.AppCenter.Crashes;

    class Program
    {
        internal class CliParams
        {
            [DirectoryArgument('s', "source", Description = "Full path to the mod directory containing mod.vdf",Example = ".\\misModPublisher.exe -s C:\\MiscreatedMods\\testMod", DirectoryMustExist = true, Optional = false)]
            public DirectoryInfo Mod_sourceDir;
            [SwitchArgument('d', "description", false, Description = "Uses description.txt to set description", Example = ".\\misModPublisher.exe -d -s C:\\MiscreatedMods\\testMod", Optional = true)]
            public bool Mod_useCustDescription;
            [SwitchArgument('t', "timestamp", false, Description = "Sets changenote to autogenerated Timestamp", Example = ".\\misModPublisher.exe -t -s C:\\MiscreatedMods\\testMod", Optional = true)]
            public bool Mod_useTimestamp;
            [SwitchArgument('n', "changeNote", false, Description = "Uses changelog.txt to set the Changelog", Example = ".\\misModPublisher.exe -n -s C:\\MiscreatedMods\\testMod", Optional = true)]
            public bool Mod_useCustChangelog;
            [SwitchArgument('c', "contributor", false, Description = "Use if you are a listed as a contributor to the mod", Example = ".\\misModPublisher.exe -c -s C:\\MiscreatedMods\\testMod", Optional = true)]
            public bool isContributor;
            [SwitchArgument('h', "help", false, Description = "Help -  show program usage")]
            public bool showUsage;
            [SwitchArgument('i', "installId", false, Description = "installId -  show current installId (only used when reporting errors)")]
            public bool showID;
        }

        static void Main(string[] args)
        {
            string InstallId = "Unset";

    #if DEBUG
            AppCenter.LogLevel = LogLevel.Verbose;
    #endif
            AppCenter.Start("bbbca620-0ad6-4548-bb0a-c08d213c01d5",
                   typeof(Analytics), typeof(Crashes));

            if (AppCenter.GetInstallIdAsync().Result.HasValue)
            {
                InstallId = AppCenter.GetInstallIdAsync().Result.Value.ToString();
                AppCenter.SetUserId(InstallId);
            }

            Task.WaitAll();
            Analytics.TrackEvent("Mod.Startup");

            string ModConfig_sourceDir;
            string ModConfig_Description;
            string ModConfig_ChangeNote;
            bool ModConfig_originalUploader;


            //Check Required files Exist
            var steam_api_64 = PathCombine(System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location), "steam_api64.dll");
            if (!File.Exists(steam_api_64))
            { // fail steam api dll missing
                Console.WriteLine("File Not Found: " + steam_api_64);
                Console.WriteLine("\nRequired SteamAPI files not found!" +
                    "\nTo fix this.  Replace the content of the ./misModPublisher directory" +
                    "\nWith the files from a fresh Release.zip on the GitHub Page.");
                Console.WriteLine("\npress any key to exit...");
                Console.ReadKey();
                return;
            }

            CommandLineParser parser = new CommandLineParser();
            CliParams obj = new CliParams();
            parser.ExtractArgumentAttributes(obj);
            parser.ShowUsageOnEmptyCommandline = true;
            parser.CheckMandatoryArguments = false;
            parser.ShowUsageHeader = "Usage: misModPublisher.exe [args]";
            
            // handle no params
            if (args.Length < 1 || args.Length > 4)
            {
                parser.ShowUsage();
                return;
            }
            else
            { parser.ParseCommandLine(args); }
            
            //arg -h|--help     Used to Show help
            if (obj.showUsage)
            {
                Analytics.TrackEvent("Show Usage"); 
                parser.ShowUsage();
                return;
            }

            //arg -i|--installId    show installId
            if (obj.showID)
            {
                Console.WriteLine(@"
        Current InstallId: " + InstallId + @"
        
        this id is only used when reporting errors. please include it when reporting errors
        its needed to find error events specific to this instance.");
                return;
            }

            if (obj.Mod_sourceDir.Exists)
            {
                ModConfig_sourceDir = obj.Mod_sourceDir.FullName;
            }
            else
            {
                Analytics.TrackEvent("Mod.InvalidSourceDir");
                ModConfig_sourceDir = "";
                return;
            }
            
            if (!obj.isContributor)
            {
                ModConfig_originalUploader = true;
                Console.WriteLine("\nMode: Creator Publishing");
            }
            else
            {
                ModConfig_originalUploader = false;
                Console.WriteLine("\nMode: Contributor Publishing");
            }

            Analytics.TrackEvent("Mod.Publish", new Dictionary<string, string> {
                    { "isOriginalUploader", ModConfig_originalUploader.ToString()},
                    { "validSource",        obj.Mod_sourceDir.Exists.ToString() },
                    { "customDescription",  obj.Mod_useCustDescription.ToString() },
                    { "customChanglog",     obj.Mod_useCustChangelog.ToString()},
                    { "timeStampEnable",    obj.Mod_useTimestamp.ToString()}
                });

            var mod = new Mod(ModConfig_sourceDir, ModConfig_originalUploader);
            if (obj.Mod_useCustDescription)
            {
                var descriptionFile = PathCombine(ModConfig_sourceDir, "description.txt");
                if (File.Exists(descriptionFile))
                { // read file for description
                    mod.Description = File.ReadAllText(descriptionFile);
                }
                else
                {
                    Analytics.TrackEvent("Mod.InvalidDescriptionFile");
                    Console.WriteLine("File Not Found: " + descriptionFile);
                    return;
                }

            }

            if (obj.Mod_useCustChangelog)
            {
                var changelogFile = PathCombine(ModConfig_sourceDir, "changelog.txt");
                if (File.Exists(changelogFile))
                { // read file for changelog
                    mod.ChangeNote = File.ReadAllText(changelogFile);
                }
                else
                {
                    Analytics.TrackEvent("Mod.InvalidChangelogFile");
                    Console.WriteLine("File Not Found: " + changelogFile);
                    return;
                }

            }

            if (!obj.Mod_useTimestamp)
            {
                ModConfig_ChangeNote = mod.ChangeNote;
            }
            else
            {
                ModConfig_ChangeNote = "Updated on " + DateTime.Now + ".";
            }
            

            try
            {
                Uploader.Init();
                if (Uploader.Upload(mod, ModConfig_ChangeNote))
                {
                    Analytics.TrackEvent("Mod.PublishCompleated");
                    Console.WriteLine(@"    Upload done

        Workshop ID:" + mod.PublishedFileId + @"
        Workshop URL: https://steamcommunity.com/sharedfiles/filedetails/?id=" + mod.PublishedFileId + @"
        OpenInSteam:  steam://url/CommunityFilePage/" + mod.PublishedFileId);

                    var ps = new ProcessStartInfo("steam://url/CommunityFilePage/" + mod.PublishedFileId)
                    {
                        UseShellExecute = true,
                        Verb = "open"
                    };
                    Process.Start(ps);
                }
                else
                {
                    Analytics.TrackEvent("Mod.PublishFailed");
                    Console.WriteLine("Upload failed :(");
                }
            }
            catch (Exception e)
            {
                Analytics.TrackEvent("Mod.Exception",new Dictionary<string, string> {
                    {"Error Message",e.ToString() }
                });
                Console.WriteLine(e.Message);
            }
            finally
            {
                Analytics.TrackEvent("Mod.Shutdown");
                Uploader.Shutdown();
            }
            Console.WriteLine("\npress any key to exit...");
            Console.ReadKey();
        }
        private static string PathCombine(params string[] parts)
        {
            return string.Join(Path.DirectorySeparatorChar.ToString(), parts);
        }
    }
}

